/* -*- c++ -*- */
//
// $Id: attribute.h 86020 2009-07-14 12:13:54Z wotte $
//

// ============================================================================
//
// = LIBRARY
//    TAO IDL
//
// = FILENAME
//    attribute.h
//
// = DESCRIPTION
//    Visitor for the Attribute class.
//
// = AUTHOR
//    Aniruddha Gokhale
//
// ============================================================================

#ifndef _BE_VISITOR_ATTRIBUTE_ATTRIBUTE_H
#define _BE_VISITOR_ATTRIBUTE_ATTRIBUTE_H

// ************************************************************
// Attribute visitor
// ************************************************************

class be_visitor_attribute : public be_visitor_decl
{
  //
  // = TITLE
  //   be_visitor_attribute
  //
  // = DESCRIPTION
  //   This is a concrete visitor to generate code for attributes. We have one
  //   class for mapping into the client and server.
  //
  //
public:
  be_visitor_attribute (be_visitor_context *ctx);
  // constructor

  ~be_visitor_attribute (void);
  // destructor

  virtual int visit_attribute (be_attribute *node);
  // visit attribute. We provide code for this method in the derived class

  void for_facets (bool val);
  void op_scope (be_interface *node);

private:
  bool for_facets_;
  be_interface *op_scope_;
};

#endif /* _BE_VISITOR_ATTRIBUTE_ATTRIBUTE_H*/
